<?php
$p_url = 'tools.php?p=referers';
$ini_file = dirname(__FILE__).'/referers.ini';

$objIni = new iniFile($ini_file);
$objIni->read($ini_file);

/* Chargement des referers
-------------------------------------------------------- */

$reffilename = 'reffichier.html';
$blacklistfilename = 'refblacklist.html';
$referants = dirname(__FILE__) . '/' . $reffilename;
$blacklist = dirname(__FILE__) . '/' . $blacklistfilename;
$err = '';

if (!file_exists($referants)) {
	$err .= '<p>' . sprintf(__('Referers file %s does not exist.'), "<strong>$referants</strong>") . '</p>';
} else if (!is_writable($referants)) {
	$err .= '<p>' . sprintf(__('Referers file %s is not writable.'), "<strong>./$reffilename</strong>") . '</p>';
}

$ini_writable = true;
if (!is_writable($ini_file)) {
	$err .= '<p>' . sprintf(__('Config file %s, is not writable.'), '<strong>./referers.ini</strong>') . '</p>';
	$ini_writable = false;
}

$bl_writable = true;
if (!file_exists($blacklist)) {
	$err .= '<p>'.sprintf(__('Black list file %s does not exist.'), "<strong>./$blacklistfilename</strong>").'</p>';
} else if (!is_writable($blacklist)) {
	$err .= '<p>'.sprintf(__('Black list file %s is not writable.'),"<strong>./$blacklistfilename</strong>").'</p>';
  $bl_writable = false;
}

/* Sauvegarde des fichiers black list et ini
-------------------------------------------------------- */
if (!empty($_POST)) {
	$all_OK = true;
	if (!empty($_POST['p_nb_display_line_config']) or !empty($_POST['p_display_filtered_config'])) {
		$p_nb_display_line_config = trim($_POST['p_nb_display_line_config']);
		$p_display_filtered_config = trim($_POST['p_display_filtered_config']);
		$objIni->editVar('ref_nb_display_line_config', (integer) $p_nb_display_line_config);
		$objIni->editVar('ref_display_filtered_config', ($p_display_filtered_config == 'display_filter') ? '1' : '0');
		if ($objIni->saveFile() === false) {
			$all_OK = false;
			$err .= __('An error occured while writing the config file.');
		}
	}
	if (!empty($_POST['f_content']) && $bl_writable) {
		$f_content = str_replace("\r",'',$_POST['f_content']);
		if (files::putContent($blacklist, $f_content) === false)	{
			$all_OK = false;
			$err = '<p>'.__('Cannot write black list file.').'</p>';
		}
	}
	if ($all_OK) {
		header('Location: '.$p_url);
		exit;
	}
}


/* Affichage
-------------------------------------------------------- */
buffer::str('<h2>'.__('Referers').'</h2>');

if($err != '')
{
	buffer::str('<div class="erreur"><p><strong>'.__('Error(s)').' </strong></p>'.$err.'</div>');
}

buffer::str('<h3>' . 
__('Usage') . '</h3><ol><li>' . __('Add a call to the function') . ' <samp>dcReferers::displayReferers()</samp> ' . __('where you want your referers to be displayed in your template file.') .
'</li><li>' . __('By default, it displays only the last five referers. If you wish to display more referers, you can pass the number as a parameter to the function.') . '</li></ol>');

buffer::str('<form action="tools.php" method="post">');

buffer::str('<fieldset><legend>' .__('Configuration') . '</legend>');

buffer::str('<fieldset><legend>' . __('Display configuration') . '</legend><p class="field"><label for="p_display_filtered_config"><strong>' . 
	__('Display filtered referers on this page?') . '</strong></label>' .  
	form::checkbox('p_display_filtered_config', 'display_filter', (ref_display_filtered_config == 1)? 1 : '') . '</p>' . "\n");

buffer::str('<p class="field"><label for="p_nb_display_line_config"><strong>' . 
	__('Number of referers to display on this page') . '</strong></label>' .  
	form::field('p_nb_display_line_config', '3', '', ref_nb_display_line_config) . '</p></fieldset>' . "\n");

buffer::str('<fieldset><legend>' . __('Black list') . '</legend><p>' . __('This black list works on the URL of the referers. The black list system uses regexps for matching, so you can take advantage of that if you wish. One entry per line only.') . '</p>');

buffer::str('<textarea id="f_content" name="f_content" rows="10" cols="60" style="width: 100%; font-family: courier,monospace;"' .
	(($bl_writable !== true)?' readonly="readonly"':'') .
	'">' . htmlspecialchars(@file_get_contents($blacklist)) . 
	'</textarea>' . 
	'<input type="hidden" name="p" value="referers" /></fieldset>' . "\n");

if ($bl_writable or $ini_writable) {
	buffer::str('<p><input type="submit" class="submit" value="' . __('save') . '" /></p>');
}
buffer::str('</fieldset></form>');

buffer::str('<h3>' . __('Last Referers') . '</h3>');

buffer::str('<table border="1"><thead><tr><th>' . __('Displayed') . '</th><th>' . __('Full referer') . '</th></tr></thead>');
if (file_exists($referants)) {
	$refarray = file($referants);
	$refreverse = array_reverse($refarray);
	$refunique = array_unique($refreverse);
	$refcount = count($refunique);
	$filter = false;

	if (file_exists($blacklist)) {
		$filter = true;
		$blarray = file($blacklist);
		$blcount = count($blarray);
	}


	if ($refcount > 0) {
		buffer::str('<tbody>');
		$refparsed = 0;
		$i = 0;
		while (($i < ref_nb_display_line_config) and ($refparsed < $refcount)) {
			if (preg_match('!href="(.+?)".*>(.+)</a>!', array_shift($refunique), $refs)) {
				$filtered = false;
				if ($filter) {
					for ($j = 0; $j < $blcount; $j++) {
						if ((trim($blarray[$j]) != '') and (preg_match('!' . trim($blarray[$j]) . '!i', $refs[1]))) {
							$filtered = true;
							break;
						}
					}
				}
				if ($filtered and ref_display_filtered_config) {
					buffer::str('<tr style="background-color: #FDB8B8;">');
					buffer::str('<td>' . $refs[2] . '</td><td>' . $refs[1] . '</td></tr>');
					$i++;
				} else if (!$filtered) {
					buffer::str('<tr>');
					buffer::str('<td>' . $refs[2] . '</td><td>' . $refs[1] . '</td></tr>');
					$i++;
				}
			}
			$refparsed++;
		}
		buffer::str('</tbody>');
	}
}
buffer::str('</table>');
buffer::str('<p>' . __('Note: in this list, lines that would be filtered by the black list are displayed with a pink background.') . '</p>');

buffer::str('<div class="copyright"><h3>' . __('Copyright information') . '</h3><p>' . 
sprintf(__('Based on code by %s and %s; plugin created by %s.'), '<a href="http://blog.lucas3d.com/">Lucas Janin</a>', 'Xavier Borderie', '<a href="http://www.mudry.org/">Julien Mudry</a>') . '</p></div>');

buffer::str('<div class="changelog"><h3>' . __('Changelog') . '</h3><h4>' . 
__('Version 0.7') . '</h4><ul><li>' . 
__('Added an option to display or not filtered lines on the config page.') . '</li><li>' .
__('Revamping of the configuration page.') . '</li><li>' . 
__('XHTML validation of the configuration page.') . '</li><li>' .
sprintf(__('Corrected a bug for referers with spaces in them. (Reported by %s.)'), 'AeN0') . '</li></ul><h4>' . 
__('Version 0.6') . '</h4><ul><li>' . 
__('Added use of attribute rel="nofollow" on links displayed.') . '</li><li>' . 
__('Added a param for the number of referers to display on the config screen.') . '</li><li>' . 
sprintf(__('Shows filtered rows in configuration with a different color (based on code by %s)'), 'Gilles CHAUVIN') . '</li></ul><h4>' . 
__('Version 0.5') . '</h4><ul><li>' . __('Added support of other protocols besides http.') . '</li></ul><h4>' . 
__('Version 0.4') . '</h4><ul><li>' . __('Changed extension of text files to html, hoping to solve one bug with Free.') . '</li></ul><h4>' . 
__('Version 0.3') . '</h4><ul><li>' . __('Black list filtering was added.') . '</li></ul><h4>' .
__('Version 0.2') . '</h4><ul><li>' . __('Correct order and number of referers.') . '</li><li>' . 
__('Use of htmlentities to store URLs.') . '</li><li>' . 
__('More correct copyright information.') . '</li></ul><h4>' .
__('Version 0.1') . '</h4><ul><li>' . __('First public version.') . '</li></ul></div>');
?>
